import React, { createContext, useContext, useEffect, useState } from 'react';
import { TagInstanceInfo } from '../api';
import { Occurrence, Tag } from '../components/types/tag';

interface IAnnotationContextProvider {
    tags: TagInstanceInfo[] | null;
    setTags: (newTags: TagInstanceInfo[] | null) => void;
    addOccurrence: (tag: Tag) => void;
    changeVisibility: (tag: Tag) => void;
    deleteOccurrence: (occurrence: Occurrence) => void;
    changePosition: (occurrence: Occurrence, newValue: number) => void;
    changeLength: (occurrence: Occurrence, newValue: number) => void;
}

export const AnnotationContext = createContext<IAnnotationContextProvider>({
    tags: null,
    setTags: (v) => {
        return;
    },
    addOccurrence: (tag: Tag) => {
        return;
    },
    changeVisibility: (tag: Tag) => {
        return;
    },
    deleteOccurrence: (occurrence: Occurrence) => {
        return;
    },
    changePosition: (occurrence: Occurrence, newValue: number) => {
        return;
    },
    changeLength: (occurrence: Occurrence, newValue: number) => {
        return;
    },
});

const AnnotationProvider = (props: { children: React.ReactNode }) => {
    const [tags, setTags] = useState<TagInstanceInfo[] | null>(null);
    const addOccurrence = (tag: Tag) => {};
    const changeVisibility = (tag: Tag) => {};
    const deleteOccurrence = (occurrence: Occurrence) => {};
    const changePosition = (occurrence: Occurrence, newValue: number) => {};
    const changeLength = (occurrence: Occurrence, newValue: number) => {};

    useEffect(() => {
        // on context init
    }, []);

    return (
        <AnnotationContext.Provider
            value={{
                tags,
                setTags,
                addOccurrence,
                changeVisibility,
                deleteOccurrence,
                changeLength,
                changePosition,
            }}
        >
            {props.children}
        </AnnotationContext.Provider>
    );
};

export default AnnotationProvider;
